#taken from: https://stackoverflow.com/questions/29954815/merge-multiple-declarative-bases-in-sqlalchemy
from sqlalchemy import MetaData
from sqlalchemy.ext.declarative import declarative_base
from .models_core import (
        Timeseries,
        TimeseriesRole,
        timeseries_timeseries_roles_table,
        Base as TimeseriesBase)
from .models_annotation import (
        TimeseriesAnnotation,
        Base as TimeseriesAnnotationBase)
from .models_programme import (
        TimeseriesProgramme,
        Base as TimeseriesProgrammBase)

Base = declarative_base()
metadata = MetaData()

from sqlalchemy import Table, String, Column, ForeignKey, Integer
from sqlalchemy.ext.declarative import declarative_base

Base = declarative_base()
metadata = Base.metadata

for declarative_base in [TimeseriesBase, TimeseriesAnnotationBase, TimeseriesProgrammBase]:
    for (table_name, table) in declarative_base.metadata.tables.items():
        metadata._add_table(table_name, table.schema, table)

Base.metadata = metadata

# controlled vocabulary
RS_enum = Table("rs_vocabulary",
                metadata,
                Column("enum_val", Integer, primary_key=True),
                Column("enum_str", String),
                Column("enum_display_str", String)
          )

RC_enum = Table("rc_vocabulary",
                metadata,
                Column("enum_val", Integer, primary_key=True),
                Column("enum_str", String),
                Column("enum_display_str", String)
          )
